% $Id: filter_inside_tests.erl,v 1.1 2013/04/11 02:23:55 leavens Exp $
-module(filter_inside_tests).
-export([main/0]).
-import(filter_inside,[filter_inside/2]).
-import(testing,[eqTest/3,startTesting/1,run_test_list/2,doneTesting/1]).

main() ->
    startTesting("FilterInsideTests $Revision: 1.1 $"),
    IT = run_test_list(0,testsInteger()),
    CT = run_test_list(IT,testsChar()),
    doneTesting(CT).

-spec testsInteger() -> [testing:testCase([[integer()]])].
testsInteger() ->
    [eqTest(filter_inside(fun (I) -> I > 2 end, []), "==", []),
     eqTest(filter_inside(fun (I) -> I > 5 end, [[]]), "==", [[]]),
     eqTest(filter_inside(fun (J) -> J > 5 end, [[1,2,3,4,5,6,7],[0,9,11]]),
         "==", [[6,7],[9,11]]),
     eqTest(filter_inside(fun (X) -> X < 4 orelse X > 7 end,
			  [[3,9,86,99,6,7,8,7,1],[0,4,9,11],[],[52,3,8,-4]]),
         "==", [[3,9,86,99,8,1],[0,9,11],[],[52,3,8,-4]])
    ].

-spec testsChar() -> [testing:testCase([[char()]])].
testsChar() -> 
    [eqTest(filter_inside(fun (C) -> C > $c end, []), "==", []),
     eqTest(filter_inside(fun (C) -> C > $a end, [[]]), "==", [[]]),
     eqTest(filter_inside(fun (C) -> C > $a end, 
	                  [[$a,$l,$p,$h,$a],"beta"]),
         "==", ["lph","bet"]),
     eqTest(filter_inside(fun (C) -> C /= $a andalso C /= $e andalso C /= $i end,
                          ["blanched cherry","pie","plain pannini","pure","pita"]),
         "==", ["blnchd chrry","p","pln pnnn","pur","pt"])
    ].
